# -*- coding: utf-8 -*-
#
# File: TRAElemento_ExportConfig.py
#
# Copyright (c) 2009 by Conselleria de Infraestructuras y Transporte de la
# Generalidad Valenciana
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
#
# Authors: 
# Conselleria de Infraestructuras y Transporte de la Generalidad Valenciana, Model Driven Development sl, Antonio Carrasco Valero
#
#

__author__ = """Conselleria de Infraestructuras y Transporte de la Generalidad Valenciana
<gvSIGi18n@gvSIG.org>, Model Driven Development sl <gvSIGi18n@ModelDD.org>,
Antonio Carrasco Valero <carrasco@ModelDD.org>"""

__docformat__ = 'plaintext'

from AccessControl                  import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.gvSIGi18n.config import *



class TRAElemento_ExportConfig:            

    """
    """
    security = ClassSecurityInfo()
    
    
    security.declarePublic('exportConfig')
    def exportConfig( self):
        return [
    {   'portal_types': [ 'TRACadena', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'simbolo',
                'type': 'string',
            },
            {   'name': 'estadoCadena',
                'type': 'selection',
            },
            {   'name': 'fechaCreacionTextual',
                'type': 'string',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaCancelacionTextual',
                'type': 'string',
            },
            {   'name': 'nombresModulos',
                'type': 'string',
            },
            {   'name': 'referenciasFuentes',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'traducciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRATraduccion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRACatalogo', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'nombreProducto',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaPorDefecto',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaRequeridoSolicitudesNuevasCadenas',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaReferenciaSolicitudesNuevasCadenas',
                'type': 'string',
            },
            {   'name': 'nombreModuloPorDefecto',
                'type': 'string',
            },
            {   'name': 'dominioPorDefecto',
                'type': 'string',
            },
            {   'name': 'maximoRegistrosExplorados',
                'type': 'Number',
            },
            {   'name': 'traduccionesPorPaginaPorDefecto',
                'type': 'Number',
            },
            {   'name': 'segundosParaConfirmarImportacion',
                'type': 'Number',
            },
            {   'name': 'formatoExportacionPorDefecto',
                'type': 'selection',
            },
            {   'name': 'incluirLocalesCSVPorDefecto',
                'type': 'selection',
            },
            {   'name': 'incluirManifestPorDefecto',
                'type': 'selection',
            },
            {   'name': 'modulosPorSeparadoPorDefecto',
                'type': 'selection',
            },
            {   'name': 'tipoArchivoExportacionPorDefecto',
                'type': 'selection',
            },
            {   'name': 'modoGestionErrorCodificacionExportacionPorDefecto',
                'type': 'selection',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'modoInteraccionPorDefecto',
                'type': 'selection',
            },
            {   'name': 'modulosYSimbolosCadenasOrdenados',
                'type': 'Text',
            },
            {   'name': 'simbolosCadenasOrdenados',
                'type': 'Text',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionIdiomas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionIdiomas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionModulos',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionModulos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionImportaciones',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionImportaciones', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionCadenas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionCadenas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionInformes',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionInformes', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionSolicitudesCadenas',
                'contains_collections': True,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionSolicitudesCadenas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'ultimaImportacion',
                'related_types': [
                    {   'portal_types': [ 'TRAImportacion', ],
                    },
                ],
            },
            {   'relation_name': 'ultimoInforme',
                'related_types': [
                    {   'portal_types': [ 'TRAInforme', ],
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionCadenas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'cadenas',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRACadena', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionIdiomas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'idiomas',
                'contains_collections': False,
                'tabular_tree':         True,
                'factory_views':                        {   'TRAIdioma': 'TRACrear_Idioma',
                },
                'subitems':             [
                    {   'portal_types': [ 'TRAIdioma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionImportaciones', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'importaciones',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAImportacion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionInformes', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'informes',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionModulos', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'modulos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAModulo', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionSolicitudesCadenas', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'solicitudesCadenas',
                'contains_collections': False,
                'tabular_tree':         True,
                'factory_views':                        {   'TRASolicitudCadena': 'TRACrear_SolicitudCadena',
                },
                'subitems':             [
                    {   'portal_types': [ 'TRASolicitudCadena', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAContenidoIntercambio', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'excluirDeImportacion',
                'type': 'Boolean',
            },
            {   'name': 'nombreModulo',
                'type': 'string',
            },
            {   'name': 'usuarioContribuidor',
                'type': 'string',
            },
            {   'name': 'fechaContenido',
                'type': 'Date',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'contenido',
                'type': 'Text',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAIdioma', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaEnGvSIG',
                'type': 'string',
            },
            {   'name': 'codigoInternacionalDeIdioma',
                'type': 'string',
            },
            {   'name': 'nombreEnInglesDeIdioma',
                'type': 'string',
            },
            {   'name': 'nombreNativoDeIdioma',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaReferencia',
                'type': 'selection',
            },
            {   'name': 'ambitoDelIdioma',
                'type': 'selection',
            },
            {   'name': 'fallbackDeIdiomas',
                'type': 'string',
            },
            {   'name': 'equipoTraductor',
                'type': 'string',
            },
            {   'name': 'juegoDeCaracteresParaJavaProperties',
                'type': 'selection',
            },
            {   'name': 'juegoDeCaracteresParaPO',
                'type': 'selection',
            },
            {   'name': 'codificacionTransferenciaContenido',
                'type': 'string',
            },
            {   'name': 'formasPlurales',
                'type': 'string',
            },
            {   'name': 'codificacionesPreferidas',
                'type': 'string',
            },
            {   'name': 'esIdiomaPrincipal',
                'type': 'Boolean',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAImportacion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'comenzarAlFinalizarAnterior',
                'type': 'Boolean',
            },
            {   'name': 'debeCrearTraduccionesQueFaltan',
                'type': 'Boolean',
            },
            {   'name': 'versionDelProducto',
                'type': 'string',
            },
            {   'name': 'buildDelProducto',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaPorDefecto',
                'type': 'string',
            },
            {   'name': 'nombreModuloPorDefecto',
                'type': 'string',
            },
            {   'name': 'maximoLineasAImportarGNUgettextPO',
                'type': 'Number',
            },
            {   'name': 'maximoLineasAImportarJavaProperties',
                'type': 'Number',
            },
            {   'name': 'intervaloRefrescoEnMinutos',
                'type': 'Number',
            },
            {   'name': 'intervaloRefrescoEnNumeroEscrituras',
                'type': 'Number',
            },
            {   'name': 'haComenzado',
                'type': 'Boolean',
            },
            {   'name': 'usuarioImportador',
                'type': 'string',
            },
            {   'name': 'estadoProceso',
                'type': 'selection',
            },
            {   'name': 'informeProgreso',
                'type': 'Text',
            },
            {   'name': 'haCompletadoConExito',
                'type': 'Boolean',
            },
            {   'name': 'fechaComienzoProceso',
                'type': 'Date',
            },
            {   'name': 'fechaFinProceso',
                'type': 'Date',
            },
            {   'name': 'informeFinal',
                'type': 'Text',
            },
            {   'name': 'informeExcepcion',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'fechaUltimoInformeProgreso',
                'type': 'Date',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'contenido',
                'contains_collections': False,
                'tabular_tree':         True,
                'factory_views':                        {   'TRAContenidoIntercambio': 'TRACrear_ContenidoIntercambio',
                },
                'subitems':             [
                    {   'portal_types': [ 'TRAContenidoIntercambio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'informesEstado',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAInforme', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'esAutoActualizable',
                'type': 'Boolean',
            },
            {   'name': 'estadoProceso',
                'type': 'selection',
            },
            {   'name': 'haComenzado',
                'type': 'Boolean',
            },
            {   'name': 'usuarioInformador',
                'type': 'string',
            },
            {   'name': 'haCompletadoConExito',
                'type': 'Boolean',
            },
            {   'name': 'fechaComienzoProceso',
                'type': 'Date',
            },
            {   'name': 'fechaFinProceso',
                'type': 'Date',
            },
            {   'name': 'informeExcepcion',
                'type': 'Text',
            },
            {   'name': 'informeIdiomas',
                'type': 'Text',
            },
            {   'name': 'informeExcepcionIdiomas',
                'type': 'Text',
            },
            {   'name': 'informeModulos',
                'type': 'Text',
            },
            {   'name': 'informeExcepcionModulos',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
            {   'name': 'minimoIntervaloActualizacionEnMinutos',
                'type': 'Number',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAModulo', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'dominio',
                'type': 'string',
            },
            {   'name': 'esModuloPrincipal',
                'type': 'Boolean',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRASolicitudCadena', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'simbolo',
                'type': 'string',
            },
            {   'name': 'estadoSolicitudCadena',
                'type': 'selection',
            },
            {   'name': 'fechaCreacionTextual',
                'type': 'string',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
            {   'name': 'fechaCancelacionTextual',
                'type': 'string',
            },
            {   'name': 'nombresModulos',
                'type': 'string',
            },
            {   'name': 'referenciasFuentes',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaPrincipal',
                'type': 'string',
            },
            {   'name': 'cadenaTraducidaAIdiomaPrincipal',
                'type': 'Text',
            },
            {   'name': 'codigoIdiomaReferencia',
                'type': 'string',
            },
            {   'name': 'cadenaTraducidaAIdiomaReferencia',
                'type': 'Text',
            },
            {   'name': 'fechaCreacion',
                'type': 'Date',
            },
            {   'name': 'fechaModificacion',
                'type': 'Date',
            },
            {   'name': 'usuarioModificador',
                'type': 'string',
            },
            {   'name': 'fechaEliminacion',
                'type': 'Date',
            },
            {   'name': 'usuarioEliminador',
                'type': 'string',
            },
            {   'name': 'registroDeCambios',
                'type': 'Text',
            },
            {   'name': 'contadorCambios',
                'type': 'Number',
            },
            {   'name': 'estaInactivo',
                'type': 'Boolean',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRATraduccion', ],
        'attrs':        [
            {   'name': 'title',
                'type': 'String',
            },
            {   'name': 'description',
                'type': 'Text',
            },
            {   'name': 'text',
                'type': 'Text',
            },
            {   'name': 'simbolo',
                'type': 'string',
            },
            {   'name': 'codigoIdiomaEnGvSIG',
                'type': 'string',
            },
            {   'name': 'cadenaTraducida',
                'type': 'string',
            },
            {   'name': 'estadoTraduccion',
                'type': 'selection',
            },
            {   'name': 'fechaTraduccionTextual',
                'type': 'string',
            },
            {   'name': 'usuarioTraductor',
                'type': 'string',
            },
            {   'name': 'fechaRevisionTextual',
                'type': 'string',
            },
            {   'name': 'usuarioRevisor',
                'type': 'string',
            },
            {   'name': 'fechaDefinitivoTextual',
                'type': 'string',
            },
            {   'name': 'usuarioCoordinador',
                'type': 'string',
            },
            {   'name': 'idCadena',
                'type': 'string',
            },
            {   'name': 'estadoCadena',
                'type': 'selection',
            },
            {   'name': 'nombresModulos',
                'type': 'string',
            },
            {   'name': 'comentario',
                'type': 'Text',
            },
            {   'name': 'indicadoresPO',
                'type': 'string',
            },
            {   'name': 'historia',
                'type': 'Text',
            },
            {   'name': 'fechaCreacionTextual',
                'type': 'string',
            },
            {   'name': 'usuarioCreador',
                'type': 'string',
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'archivos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'File', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'documentos',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Document', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'enlaces',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'Link', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':       'imagenes',
                'contains_collections':   False,
                'tabular_tree':           True,
                'non_framework_elements': True,
                'subitems':               [
                    {   'portal_types': [ 'Image', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'noticias',
                'contains_collections': False,
                'tabular_tree':         True,
                'subitems':             [
                    {   'portal_types': [ 'News_Item', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
]
