# -*- coding: utf-8 -*-
#
# File: TRAElemento_TraversalConfig.py
## Copyright (c) 2009 by Conselleria de Infraestructuras y Transporte de la
# Generalidad Valenciana
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
#
# Authors: 
# Conselleria de Infraestructuras y Transporte de la Generalidad Valenciana, Model Driven Development sl, Antonio Carrasco Valero
#
#

__author__ = """Conselleria de Infraestructuras y Transporte de la Generalidad Valenciana
<gvSIGi18n@gvSIG.org>, Model Driven Development sl <gvSIGi18n@ModelDD.org>,
Antonio Carrasco Valero <carrasco@ModelDD.org>"""

__docformat__ = 'plaintext'

from AccessControl                  import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.gvSIGi18n.config import *



class TRAElemento_TraversalConfig:            

    """
    """
    security = ClassSecurityInfo()

    security.declarePublic('traversalConfig')
    def traversalConfig( self):
        return [
    {   'portal_types': [ 'TRACadena', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRACadena', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'simbolo',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'estadoCadena',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'fechaCreacionTextual',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'usuarioCreador',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'fechaCancelacionTextual',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'nombresModulos',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'referenciasFuentes',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'simboloEnPalabras',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'traducciones',
                'columns':              [ 'title', 'description', 'codigoIdiomaEnGvSIG', 'estadoTraduccion', 'fechaTraduccion', 'usuarioTraductor', 'fechaRevision', 'usuarioRevisor', 'fechaDefinitivo', 'usuarioCoordinador', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'subitems':             [
                    {   'portal_types': [ 'TRATraduccion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRACatalogo', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRACatalogo', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':      'permiteModificar',
                'kind':      'Data',
                'type':      'Boolean',
                'optional':  True,
                'read_only': True,
            },
            {   'name':     'nombreProducto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoIdiomaPorDefecto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoIdiomaRequeridoSolicitudesNuevasCadenas',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoIdiomaReferenciaSolicitudesNuevasCadenas',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'nombreModuloPorDefecto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'dominioPorDefecto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'maximoRegistrosExplorados',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':     'traduccionesPorPaginaPorDefecto',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':     'segundosParaConfirmarImportacion',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':     'formatoExportacionPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'incluirLocalesCSVPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'incluirManifestPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'modulosPorSeparadoPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'tipoArchivoExportacionPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'modoGestionErrorCodificacionExportacionPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'ultimaVersionImportada',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'ultimoBuildImportado',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'fechaUltimaImportacion',
                'kind':     'Data',
                'type':     'DateTime',
                'optional': True,
            },
            {   'name':     'fechaUltimoInforme',
                'kind':     'Data',
                'type':     'DateTime',
                'optional': True,
            },
            {   'name':     'modoInteraccionPorDefecto',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'coleccionIdiomas',
                'columns':              [ 'title', 'description', ],
                'contains_collections': True,
                'tabular_tree':         True,
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionIdiomas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionModulos',
                'columns':              [ 'title', 'description', ],
                'contains_collections': True,
                'tabular_tree':         True,
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionModulos', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionImportaciones',
                'columns':              [ 'title', 'description', ],
                'contains_collections': True,
                'tabular_tree':         True,
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionImportaciones', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionCadenas',
                'columns':              [ 'title', 'description', ],
                'contains_collections': True,
                'tabular_tree':         True,
                'exclude_from_views':   [ 'Textual', 'Tabular', 'General', ],
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionCadenas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionInformes',
                'columns':              [ 'title', 'description', ],
                'contains_collections': True,
                'tabular_tree':         True,
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionInformes', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'aggregation_name':     'coleccionSolicitudesCadenas',
                'columns':              [ 'title', 'description', ],
                'contains_collections': True,
                'tabular_tree':         True,
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAColeccionSolicitudesCadenas', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name': 'ultimaImportacion',
                'columns':       [ 'title', 'description', 'versionDelProducto', 'buildDelProducto', 'estadoProceso', 'haCompletadoConExito', 'fechaFinProceso', ],
                'related_types': [
                    {   'portal_types': [ 'TRAImportacion', ],
                        'reuse_config': 'Default',
                    },
                ],
                'read_only':     True,
            },
            {   'relation_name': 'ultimoInforme',
                'columns':       [ 'title', 'description', 'esAutoActualizable', 'estadoProceso', 'fechaFinProceso', 'haCompletadoConExito', ],
                'related_types': [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
                'read_only':     True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionCadenas', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionCadenas', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'cadenas',
                'columns':              [ 'title', 'description', 'simbolo', 'estadoCadena', 'fechaCreacionTextual', 'usuarioCreador', 'fechaCancelacionTextual', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'exclude_from_views':   [ 'Textual', 'Tabular', 'General', ],
                'subitems':             [
                    {   'portal_types': [ 'TRACadena', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionIdiomas', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionIdiomas', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'idiomas',
                'columns':              [ 'title', 'description', 'codigoIdiomaEnGvSIG', 'codigoInternacionalDeIdioma', 'nombreNativoDeIdioma', 'codigoIdiomaReferencia', 'ambitoDelIdioma', 'juegoDeCaracteresParaJavaProperties', 'juegoDeCaracteresParaPO', 'fallbackDeIdiomas', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'factory_views':                        {   'TRAIdioma': 'TRACrear_Idioma',
                },
                'subitems':             [
                    {   'portal_types': [ 'TRAIdioma', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionImportaciones', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionImportaciones', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'importaciones',
                'columns':              [ 'title', 'description', 'comenzarAlFinalizarAnterior', 'debeCrearTraduccionesQueFaltan', 'estadoProceso', 'haComenzado', 'haCompletadoConExito', 'fechaFinProceso', 'versionDelProducto', 'buildDelProducto', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'subitems':             [
                    {   'portal_types': [ 'TRAImportacion', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionInformes', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionInformes', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'informes',
                'columns':              [ 'title', 'description', 'esAutoActualizable', 'estadoProceso', 'fechaFinProceso', 'haCompletadoConExito', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'subitems':             [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionModulos', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionModulos', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'modulos',
                'columns':              [ 'title', 'description', 'esModuloPrincipal', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'read_only':            True,
                'subitems':             [
                    {   'portal_types': [ 'TRAModulo', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionSolicitudesCadenas', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAColeccionSolicitudesCadenas', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'solicitudesCadenas',
                'columns':              [ 'title', 'description', 'simbolo', 'estadoSolicitudCadena', 'codigoIdiomaPrincipal', 'cadenaTraducidaAIdiomaPrincipal', 'codigoIdiomaReferencia', 'cadenaTraducidaAIdiomaReferencia', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'factory_views':                        {   'TRASolicitudCadena': 'TRACrear_SolicitudCadena',
                },
                'subitems':             [
                    {   'portal_types': [ 'TRASolicitudCadena', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAContenidoIntercambio', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAContenidoIntercambio', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'excluirDeImportacion',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'nombreModulo',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':      'usuarioContribuidor',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaContenido',
                'kind':      'Data',
                'type':      'Date',
                'optional':  True,
                'read_only': True,
            },
            {   'name':                     'sumarioContenido',
                'kind':                     'Data',
                'type':                     '',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'Tabular', ],
                'exclude_from_values_form': True,
            },
            {   'name':                     'informeContenido',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'Tabular', ],
                'custom_presentation_view': 'TRAContenidoIntercambioTraducciones_i18n_view',
            },
        ],
    },
    {   'portal_types': [ 'TRAIdioma', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAIdioma', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'permiteLeer',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'permiteModificar',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'codigoIdiomaEnGvSIG',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoInternacionalDeIdioma',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'nombreEnInglesDeIdioma',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'nombreNativoDeIdioma',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoIdiomaReferencia',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'ambitoDelIdioma',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'fallbackDeIdiomas',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'equipoTraductor',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'juegoDeCaracteresParaJavaProperties',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'juegoDeCaracteresParaPO',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'codificacionTransferenciaContenido',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'formasPlurales',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codificacionesPreferidas',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'esIdiomaPrincipal',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAImportacion', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAImportacion', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'comenzarAlFinalizarAnterior',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'debeCrearTraduccionesQueFaltan',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'versionDelProducto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'buildDelProducto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoIdiomaPorDefecto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'nombreModuloPorDefecto',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'maximoLineasAImportarGNUgettextPO',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':     'maximoLineasAImportarJavaProperties',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':     'intervaloRefrescoEnMinutos',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':     'intervaloRefrescoEnNumeroEscrituras',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
            {   'name':      'haComenzado',
                'kind':      'Data',
                'type':      'Boolean',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'usuarioImportador',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'estadoProceso',
                'kind':      'Data',
                'type':      'selection',
                'optional':  True,
                'read_only': True,
            },
            {   'name':                     'informeProgreso',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeProgreso_i18n_view',
                'read_only':                True,
            },
            {   'name':      'haCompletadoConExito',
                'kind':      'Data',
                'type':      'Boolean',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaComienzoProceso',
                'kind':      'Data',
                'type':      'Date',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaFinProceso',
                'kind':      'Data',
                'type':      'Date',
                'optional':  True,
                'read_only': True,
            },
            {   'name':                     'informeFinal',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeFinal_i18n_view',
                'read_only':                True,
            },
            {   'name':      'informeExcepcion',
                'kind':      'Data',
                'type':      'Text',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaUltimoInformeProgreso',
                'kind':      'Data',
                'type':      'Date',
                'optional':  True,
                'read_only': True,
            },
            {   'name':                     'informeContenidosImportacion',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'Tabular', ],
                'custom_presentation_view': 'TRAInformeContenidosImportacion_i18n_view',
            },
            {   'name':                     'informeEstadoIdiomasAntes',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeEstadoIdiomasAntes_i18n_view',
                'read_only':                True,
            },
            {   'name':                     'informeEstadoIdiomasDespues',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeEstadoIdiomasDespues_i18n_view',
                'read_only':                True,
            },
            {   'name':                     'informeEstadoModulosAntes',
                'kind':                     'Data',
                'type':                     '',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeEstadoModulosAntes_i18n_view',
                'read_only':                True,
            },
            {   'name':                     'informeEstadoModulosDespues',
                'kind':                     'Data',
                'type':                     '',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeEstadoModulosDespues_i18n_view',
                'read_only':                True,
            },
        ],
        'traversals':   [
            {   'aggregation_name':     'contenido',
                'columns':              [ 'title', 'description', 'excluirDeImportacion', 'nombreModulo', 'usuarioContribuidor', 'fechaContenido', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'factory_views':                        {   'TRAContenidoIntercambio': 'TRACrear_ContenidoIntercambio',
                },
                'subitems':             [
                    {   'portal_types': [ 'TRAContenidoIntercambio', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
            {   'relation_name':      'informeEstadoAntes',
                'columns':            [ 'title', 'description', ],
                'exclude_from_views': [ 'Textual', 'General', ],
                'related_types':      [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
                'read_only':          True,
            },
            {   'relation_name':      'informeEstadoDespues',
                'columns':            [ 'title', 'description', ],
                'exclude_from_views': [ 'Textual', 'General', ],
                'related_types':      [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
                'read_only':          True,
            },
            {   'aggregation_name':     'informesEstado',
                'columns':              [ 'title', 'description', 'esAutoActualizable', 'estadoProceso', 'fechaFinProceso', 'haCompletadoConExito', ],
                'contains_collections': False,
                'tabular_tree':         False,
                'exclude_from_views':   [ 'Textual', 'Tabular', ],
                'subitems':             [
                    {   'portal_types': [ 'TRAInforme', ],
                        'reuse_config': 'Default',
                    },
                ],
            },
        ],
    },
    {   'portal_types': [ 'TRAInforme', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAInforme', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'esAutoActualizable',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':      'estadoProceso',
                'kind':      'Data',
                'type':      'selection',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'haComenzado',
                'kind':      'Data',
                'type':      'Boolean',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'usuarioInformador',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'haCompletadoConExito',
                'kind':      'Data',
                'type':      'Boolean',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaComienzoProceso',
                'kind':      'Data',
                'type':      'Date',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaFinProceso',
                'kind':      'Data',
                'type':      'Date',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'informeExcepcion',
                'kind':      'Data',
                'type':      'Text',
                'optional':  True,
                'read_only': True,
            },
            {   'name':                     'informeIdiomas',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeIdiomas_i18n_view',
                'read_only':                True,
            },
            {   'name':      'informeExcepcionIdiomas',
                'kind':      'Data',
                'type':      'Text',
                'optional':  True,
                'read_only': True,
            },
            {   'name':                     'informeModulos',
                'kind':                     'Data',
                'type':                     'Text',
                'optional':                 True,
                'exclude_from_views':       [ 'Textual', 'General', ],
                'custom_presentation_view': 'TRAInformeModulos_i18n_view',
                'read_only':                True,
            },
            {   'name':      'informeExcepcionModulos',
                'kind':      'Data',
                'type':      'Text',
                'optional':  True,
                'read_only': True,
            },
            {   'name':     'minimoIntervaloActualizacionEnMinutos',
                'kind':     'Data',
                'type':     'Number',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAModulo', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRAModulo', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'permiteLeer',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'permiteModificar',
                'kind':     'Data',
                'type':     'Boolean',
                'optional': True,
            },
            {   'name':     'dominio',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRASolicitudCadena', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRASolicitudCadena', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':      'simbolo',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'estadoSolicitudCadena',
                'kind':      'Data',
                'type':      'selection',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaCreacionTextual',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'usuarioCreador',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':      'fechaCancelacionTextual',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':     'nombresModulos',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'referenciasFuentes',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':      'codigoIdiomaPrincipal',
                'kind':      'Data',
                'type':      'string',
                'optional':  True,
                'read_only': True,
            },
            {   'name':     'cadenaTraducidaAIdiomaPrincipal',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':     'codigoIdiomaReferencia',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'cadenaTraducidaAIdiomaReferencia',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRATraduccion', ],
        'config_name':  'Mention',
        'mode':         'Reference',
        'extension':    'OneParagraph',
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
        ],
    },
    {   'portal_types': [ 'TRATraduccion', ],
        'extension':    'NonTextAttrsOneParagraph',
        'divider':      [ 'Before', ],
        'attrs':        [
            {   'name': 'title',
                'kind': 'Data',
                'type': 'String',
            },
            {   'name': 'archetype_name',
                'kind': 'Meta',
                'type': 'String',
            },
            {   'name':     'description',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':       'text',
                'kind':       'Data',
                'type':       'Text',
                'optional':   True,
                'hide_label': True,
            },
            {   'name':     'simbolo',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'codigoIdiomaEnGvSIG',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'cadenaTraducida',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'estadoTraduccion',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'fechaTraduccionTextual',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'usuarioTraductor',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'fechaRevisionTextual',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'usuarioRevisor',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'fechaDefinitivoTextual',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'usuarioCoordinador',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'idCadena',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'estadoCadena',
                'kind':     'Data',
                'type':     'selection',
                'optional': True,
            },
            {   'name':     'nombresModulos',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'comentario',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':     'indicadoresPO',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'historia',
                'kind':     'Data',
                'type':     'Text',
                'optional': True,
            },
            {   'name':     'fechaCreacionTextual',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
            {   'name':     'usuarioCreador',
                'kind':     'Data',
                'type':     'string',
                'optional': True,
            },
        ],
    },
]
